import Qt 4.7

Rectangle {

    property int stateIndex: 1

    Text {
        text: "State: " + parent.state
        z: 0.1
    }

    id: rootRect
    width: 200
    height: 200

    Rectangle {
        id: sibling1
        color: "green"
        width: parent.width / 2
        height: parent.height / 2
    }

    Rectangle {
        id: sibling2
        color: "yellow"
        width: parent.width / 2
        height: parent.height / 2
    }

    states: [
        State {
            name: "left to right"
            when: stateIndex == 1
            AnchorChanges {
                target: sibling1
                anchors.left: parent.left
                anchors.top: parent.top
                anchors.bottom: parent.bottom
            }
            AnchorChanges {
                target: sibling2
                anchors.top: parent.top
                anchors.bottom: parent.bottom
                anchors.right: parent.right
                anchors.left: sibling1.right
            }
            PropertyChanges {
                target: sibling1
                height: rootRect.height
                width: rootRect.width / 2
            }
            PropertyChanges {
                target: sibling2
                height: rootRect.height
                width: rootRect.width / 2
            }
        },
        State {
            name: "bottom-left to top-right"
            when: stateIndex == 2
            AnchorChanges {
                target: sibling1
                anchors.right: parent.right
                anchors.top: parent.top
            }
            AnchorChanges {
                target: sibling2
                anchors.top: sibling1.bottom
                anchors.bottom: parent.bottom
                anchors.left: parent.left
                anchors.right: sibling1.left
            }
            PropertyChanges {
                target: sibling1
                height: rootRect.height / 2
                width: rootRect.width / 2
            }
            PropertyChanges {
                target: sibling2
                height: rootRect.height / 2
                width: rootRect.width / 2
            }
        },
        State {
            name: "inside with margins"
            when: stateIndex == 3
            AnchorChanges {
                target: sibling1
                anchors.top: rootRect.top
                anchors.bottom: rootRect.bottom
                anchors.right: rootRect.right
                anchors.left: rootRect.left
            }
            AnchorChanges {
                target: sibling2
                anchors.left: sibling1.left
                anchors.right: sibling1.right
                anchors.top: sibling1.top
                anchors.bottom: sibling1.bottom
            }
            PropertyChanges {
                target: sibling2
                anchors.margins: 10
            }
        },
        State {
            name: "centered with offset"
            when: stateIndex == 4
            AnchorChanges {
                target: sibling1
                anchors.top: rootRect.top
                anchors.bottom: rootRect.bottom
                anchors.right: rootRect.right
                anchors.left: rootRect.left
            }
            AnchorChanges {
                target: sibling2
                anchors.verticalCenter: sibling1.verticalCenter
                anchors.horizontalCenter: sibling1.horizontalCenter
            }
            PropertyChanges {
                target: sibling2
                anchors.verticalCenterOffset: 25
                anchors.horizontalCenterOffset: 25
                width: rootRect.height / 2
                height: rootRect.height / 2
            }
        }
    ]

    transitions: [
        Transition {
            AnchorAnimation {}
        }
    ]


    MouseArea {
        anchors.fill: parent
        onClicked:  {
            parent.stateIndex++;
            if (parent.stateIndex == 5) {
                parent.stateIndex = 1;
            }
        }
    }
}
