import Qt 4.7

Rectangle {

    id: filterArea
    property string message

    Rectangle {
        id: rectangle2
        color: "white"
        anchors.left: parent.left
        anchors.right: submitButton.left
        anchors.bottom: parent.bottom
        anchors.top: parent.top
        Rectangle {
            color: "white"
            radius: 5
            border.color: "black"
            border.width: 1
            anchors.margins: 5
            anchors.fill: parent
            TextInput {
                id: filterInput
                text: ""
                x: 10; y: (parent.height - height) / 2; width: parent.width - 20
                onAccepted: filterArea.message = text
            }
        }

        // The TextInput is quite small compared to surrounding rectangle,
        // so it's better to accept focus also from the surrounding areas.
        MouseArea {
            anchors.fill: parent
            onClicked: filterInput.focus = true
        }
    }

    Rectangle {
        id: submitButton
        width: 50
        border.color: "black"
        border.width: 1
        radius: 5
        anchors.bottom: parent.bottom
        anchors.top: parent.top
        anchors.right: parent.right
        anchors.margins: 5
        Text {
            anchors.fill: parent
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            text: "Submit"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: filterArea.message = filterInput.text
        }
    }
}
