import Qt 4.7

Rectangle {

    property int stateIndex: 1

    Text {
        text: "State: " + parent.state
        z: 0.1
        anchors.right: parent.right
        anchors.bottom: parent.bottom
        anchors.margins: 25
    }

    width: 350
    height: 350
    Column {
        id: lightsColumn
        anchors.fill: parent
        spacing: 10
        Light { color: "red" }
        Light { color: "yellow" }
        Light { color: "green" }
        Light { color: "blue" }
        opacity: parent.state == "Column" ? 1 : 0
    }

    Row {
        id: lightsRow
        anchors.fill: parent
        spacing: 10
        Light { color: "red" }
        Light { color: "yellow" }
        Light { color: "green" }
        Light { color: "blue" }
        opacity: parent.state == "Row" ? 1 : 0
    }

    Grid {
        id: lightsGrid
        columns: 2
        anchors.fill: parent
        spacing: 10
        Light { color: "red" }
        Light { color: "yellow" }
        Light { color: "green" }
        Light { color: "blue" }
        opacity: parent.state == "Grid" ? 1 : 0
    }

    Flow {
        id: lightsFlow
        anchors.fill: parent
        spacing: 10
        Light { color: "red" }
        Light { color: "yellow" }
        Light { color: "green" }
        Light { color: "blue" }
        opacity: parent.state == "Flow" ? 1 : 0
    }

    states: [
        State {
            when: stateIndex == 1
            name: "Column"
        },
        State {
            when: stateIndex == 2
            name: "Row"
        },
        State {
            when: stateIndex == 3
            name: "Grid"
        },
        State {
            when: stateIndex == 4
            name: "Flow"
        }
    ]

    MouseArea {
        anchors.fill: parent
        onClicked:  {
            parent.stateIndex++;
            if (parent.stateIndex == 5) {
                parent.stateIndex = 1;
            }
        }
    }
}
