import Qt 4.7

// Some rectangles
Rectangle {
    width: 200
    height: 200

    // Single color
    Rectangle {
        width: 100; height: 100
        color: "lightblue"
    }

    // Vertical gradient
    Rectangle {
        x: 0; y: 100; width: 100; height: 100
        gradient: Gradient {
            GradientStop { position: 0; color: "red" }
            GradientStop { position: 0.5; color: "green" }
            GradientStop { position: 1; color: "blue" }
        }
    }

    // Single color with radius and border
    // Note that the border takes border.width
    // amount of space outside the rectangle
    // and same amount of space inside.
    // Thus, rectangle must be positioned at border.width / 2
    // and rectangle width must be border.width less than expected
    Rectangle {
        x: 102; y: 2; width: 96; height: 96
        color: "lightblue"
        border.color: "blue"
        border.width: 4
        radius: 10
    }

    // Non-vertical gradient is done with help of rotation
    // Note the usage of clip property to prevent child
    // items from being drawn outside their parent
    Rectangle {
        x: 100; y: 100; width: 100; height: 100
        clip: true
        Rectangle {
            x: -25; y: -25; width: 150; height: 150
            rotation: 28
            gradient: Gradient {
                GradientStop { position: 0; color: "red" }
                GradientStop { position: 0.5; color: "green" }
                GradientStop { position: 1; color: "blue" }
            }
        }
    }
}
